define([
    "dojo/_base/declare",
    "epi-cms/component/command/_GlobalToolbarCommandProvider",
    "epi-cms/notification/NotificationButton",
    "epi-cms/notification/command/ViewNotifications",
    "epi-cms/ApplicationSettings"
], function (
    declare,
    _GlobalToolbarCommandProvider,
    NotificationButton,
    ViewNotificationsCommand,
    ApplicationSettings
) {

    return declare([_GlobalToolbarCommandProvider], {
        // summary:
        //    A command provider providing notification commands to the global toolbar

        // isProjectModeEnabled: [readonly] Boolean
        //      Indicates whether project mode is enabled.
        isProjectModeEnabled: false,

        postscript: function () {
            this.inherited(arguments);

            this.isProjectModeEnabled = this.isProjectModeEnabled || ApplicationSettings.isProjectModeEnabled;
            if (!this.isProjectModeEnabled) {
                return;
            }

            var settings = {
                widget: NotificationButton,
                "class": "epi-chromeless"
            };
            this.addToTrailing(new ViewNotificationsCommand(), settings);
        }
    });
});
